export function sortArray(array, on, order = "asc") {
    const selector = (item) => on === undefined ? item : item[on];
    const modifier = order === "asc" ? 1 : -1;
    return _sortArray(array, selector, modifier);
}
export function _sortArray(array, selector, modifier) {
    return [...array].sort((first, second) => {
        if (selector(first) < selector(second)) {
            return -1 * modifier;
        }
        if (selector(first) > selector(second)) {
            return 1 * modifier;
        }
        return 0;
    });
}
