"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var src_1 = __importStar(require("../src"));
test("sorts correctly an array of strings (ascending)", function () {
    expect((0, src_1.default)(["delta", "alpha", "beta", "gamma", "epsilon"])).toStrictEqual(["alpha", "beta", "delta", "epsilon", "gamma"]);
});
test("sorts correctly an array of strings (descending)", function () {
    expect((0, src_1.default)(["delta", "alpha", "beta", "gamma", "epsilon"], undefined, "desc")).toStrictEqual(["gamma", "epsilon", "delta", "beta", "alpha"]);
});
test("sorts correctly an array of numbers (ascending)", function () {
    expect((0, src_1.default)([5, 2, 1, 3, 4])).toStrictEqual([1, 2, 3, 4, 5]);
});
test("sorts correctly an array of numbers (descending)", function () {
    expect((0, src_1.default)([5, 2, 1, 3, 4], undefined, "desc")).toStrictEqual([
        5, 4, 3, 2, 1,
    ]);
});
test("sorts correctly an array of objects on a specific property (ascending)", function () {
    expect((0, src_1.default)([
        { letter: "delta" },
        { letter: "alpha" },
        { letter: "beta" },
        { letter: "gamma" },
        { letter: "epsilon" },
    ], "letter")).toStrictEqual([
        { letter: "alpha" },
        { letter: "beta" },
        { letter: "delta" },
        { letter: "epsilon" },
        { letter: "gamma" },
    ]);
});
test("sorts correctly an array of objects on a specific property (descending)", function () {
    expect((0, src_1.default)([
        { letter: "delta" },
        { letter: "alpha" },
        { letter: "beta" },
        { letter: "gamma" },
        { letter: "epsilon" },
    ], "letter", "desc")).toStrictEqual([
        { letter: "gamma" },
        { letter: "epsilon" },
        { letter: "delta" },
        { letter: "beta" },
        { letter: "alpha" },
    ]);
});
test("sorts correctly an array of objects on a specific date property (ascending)", function () {
    expect((0, src_1.default)([
        { letter: "delta", created: new Date(2021, 10, 26, 6, 47) },
        { letter: "alpha", created: new Date(2021, 10, 26, 6, 45) },
        { letter: "beta", created: new Date(2021, 10, 26, 6, 48) },
        { letter: "gamma", created: new Date(2021, 10, 26, 6, 46) },
        { letter: "epsilon", created: new Date(2021, 10, 26, 6, 49) },
    ], "created")).toStrictEqual([
        { letter: "alpha", created: new Date(2021, 10, 26, 6, 45) },
        { letter: "gamma", created: new Date(2021, 10, 26, 6, 46) },
        { letter: "delta", created: new Date(2021, 10, 26, 6, 47) },
        { letter: "beta", created: new Date(2021, 10, 26, 6, 48) },
        { letter: "epsilon", created: new Date(2021, 10, 26, 6, 49) },
    ]);
});
test("sorts correctly an array of objects on a specific date property (descending)", function () {
    expect((0, src_1.default)([
        { letter: "delta", created: new Date(2021, 10, 26, 6, 47) },
        { letter: "alpha", created: new Date(2021, 10, 26, 6, 45) },
        { letter: "beta", created: new Date(2021, 10, 26, 6, 48) },
        { letter: "gamma", created: new Date(2021, 10, 26, 6, 46) },
        { letter: "epsilon", created: new Date(2021, 10, 26, 6, 49) },
    ], "created", "desc")).toStrictEqual([
        { letter: "epsilon", created: new Date(2021, 10, 26, 6, 49) },
        { letter: "beta", created: new Date(2021, 10, 26, 6, 48) },
        { letter: "delta", created: new Date(2021, 10, 26, 6, 47) },
        { letter: "gamma", created: new Date(2021, 10, 26, 6, 46) },
        { letter: "alpha", created: new Date(2021, 10, 26, 6, 45) },
    ]);
});
test("sorts correctly an array of objects with a deep selector (ascending)", function () {
    expect(new src_1.ArraySorter([
        { a: { b: { c: 3 } } },
        { a: { b: { c: 5 } } },
        { a: { b: { c: 1 } } },
        { a: { b: { c: 2 } } },
        { a: { b: { c: 4 } } },
    ]).sort(["a", "b", "c"], "asc")).toStrictEqual([
        { a: { b: { c: 1 } } },
        { a: { b: { c: 2 } } },
        { a: { b: { c: 3 } } },
        { a: { b: { c: 4 } } },
        { a: { b: { c: 5 } } },
    ]);
});
test("sorts correctly an array of objects with a deep selector (descending)", function () {
    expect(new src_1.ArraySorter([
        { a: { b: { c: 3 } } },
        { a: { b: { c: 5 } } },
        { a: { b: { c: 1 } } },
        { a: { b: { c: 2 } } },
        { a: { b: { c: 4 } } },
    ]).sort(["a", "b", "c"], "desc")).toStrictEqual([
        { a: { b: { c: 5 } } },
        { a: { b: { c: 4 } } },
        { a: { b: { c: 3 } } },
        { a: { b: { c: 2 } } },
        { a: { b: { c: 1 } } },
    ]);
});
